#ifndef EFL_GENERATED_ELM_INTERFACE_ATSPI_SELECTION_HH
#define EFL_GENERATED_ELM_INTERFACE_ATSPI_SELECTION_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_interface_atspi_selection.eo.h"
}


struct elm_interface_atspi_selection;

/// @cond EO_CXX_ABSTRACT
namespace eo_cxx {

struct elm_interface_atspi_selection
{
#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
   /// @param child_index 
   ///
   bool child_select(int child_index_) const;
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
   /// @param child_index 
   ///
   bool selected_child_deselect(int child_index_) const;
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
   /// @param child_index 
   ///
   bool is_child_selected(int child_index_) const;
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
   bool all_children_select() const;
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
   bool clear() const;
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
   /// @param child_index 
   ///
   bool child_deselect(int child_index_) const;
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
   int selected_children_count_get() const;
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
   ::efl::eo::concrete selected_child_get(int selected_child_index_) const;
#endif

   template <typename F>
   ::efl::eo::signal_connection
   callback_selection_changed_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_SELECTION_EVENT_SELECTION_CHANGED, priority_,
            &::efl::eo::_detail::event_callback<::elm_interface_atspi_selection, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_interface_atspi_selection, function_type>,
         ELM_INTERFACE_ATSPI_SELECTION_EVENT_SELECTION_CHANGED );
   }

   template <typename T>
   void
   callback_selection_changed_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_SELECTION_EVENT_SELECTION_CHANGED, info));
   }



   static Eo_Class const* _eo_class()
   {
      return(ELM_INTERFACE_ATSPI_SELECTION_INTERFACE);
   }

   operator ::elm_interface_atspi_selection() const;
   operator ::elm_interface_atspi_selection&();
   operator ::elm_interface_atspi_selection const&() const;

   /// @cond LOCAL
   template <typename D>
   struct address_of
   {
      operator ::elm_interface_atspi_selection*() const { return static_cast<::elm_interface_atspi_selection*>(static_cast<D const*>(this)->p); }
      operator ::elm_interface_atspi_selection const*() const { return static_cast<::elm_interface_atspi_selection const*>(static_cast<D const*>(this)->p); }
   };

   template <typename D>
   struct address_const_of
   {
      operator ::elm_interface_atspi_selection const*() const { return static_cast<::elm_interface_atspi_selection const*>(static_cast<D const*>(this)->p); }
   };
   /// @endcond

private:

   /// @internal
   Eo* _concrete_eo_ptr() const
   {
      return static_cast<::efl::eo::concrete const*>(static_cast<void const*>(this))->_eo_ptr();
   }

};

}
/// @endcond

/// @brief Class elm_interface_atspi_selection
struct elm_interface_atspi_selection
      : ::efl::eo::concrete
{
   //@{
   /**
      @brief Constructs a new elm_interface_atspi_selection object.

      Constructs a new elm_interface_atspi_selection object. If you want this object to be a child
      of another Eo object, use an @ref efl::eo::parent expression, like the example.

      Example:
      @code
      elm_interface_atspi_selection my_elm_interface_atspi_selection(efl::eo::parent = parent_object);
      @endcode

      @see elm_interface_atspi_selection(Eo* eo)
   */
   explicit elm_interface_atspi_selection(::efl::eo::parent_type _p)
      : elm_interface_atspi_selection(_ctors_call(_p))
   {}

   explicit elm_interface_atspi_selection()
      : elm_interface_atspi_selection(_ctors_call(::efl::eo::parent = nullptr))
   {}
   //@}

   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_interface_atspi_selection(Eo* eo)
      : ::efl::eo::concrete(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_interface_atspi_selection(std::nullptr_t)
      : ::efl::eo::concrete(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   elm_interface_atspi_selection(elm_interface_atspi_selection const& other)
      : elm_interface_atspi_selection(eo_ref(other._eo_ptr()))
   {}

   ~elm_interface_atspi_selection() {}

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
   /// @param child_index 
   ///
   bool child_select(int child_index_) const;
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
   /// @param child_index 
   ///
   bool selected_child_deselect(int child_index_) const;
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
   /// @param child_index 
   ///
   bool is_child_selected(int child_index_) const;
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
   bool all_children_select() const;
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
   bool clear() const;
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
   /// @param child_index 
   ///
   bool child_deselect(int child_index_) const;
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
   int selected_children_count_get() const;
#endif

#ifdef ELM_INTERFACE_ATSPI_SELECTION_PROTECTED
   ::efl::eo::concrete selected_child_get(int selected_child_index_) const;
#endif

   template <typename F>
   ::efl::eo::signal_connection
   callback_selection_changed_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_SELECTION_EVENT_SELECTION_CHANGED, priority_,
            &::efl::eo::_detail::event_callback<::elm_interface_atspi_selection, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_interface_atspi_selection, function_type>,
         ELM_INTERFACE_ATSPI_SELECTION_EVENT_SELECTION_CHANGED );
   }

   template <typename T>
   void
   callback_selection_changed_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_SELECTION_EVENT_SELECTION_CHANGED, info));
   }



   static Eo_Class const* _eo_class()
   {
      return(ELM_INTERFACE_ATSPI_SELECTION_INTERFACE);
   }

   /// @cond LOCAL
   struct address_of
      : ::eo_cxx::elm_interface_atspi_selection::address_of<address_of>
      , ::efl::eo::detail::concrete_address_of
   {
      explicit address_of(::elm_interface_atspi_selection* p)
         : ::efl::eo::detail::concrete_address_of(p)
      {}
   };
   address_of operator&() { return address_of(this); }

   struct address_const_of
      : ::eo_cxx::elm_interface_atspi_selection::address_const_of<address_const_of>
      , ::efl::eo::detail::concrete_address_const_of
   {
      explicit address_const_of(::elm_interface_atspi_selection const* p)
         : ::efl::eo::detail::concrete_address_const_of(p)
      {}
   };
   address_const_of operator&() const { return address_const_of(this); }

   /// @endcond

private:

   /// @internal
   static Eo* _ctors_call(::efl::eo::parent_type _p)
   {
      Eo* _ret_eo = eo_add_ref(ELM_INTERFACE_ATSPI_SELECTION_INTERFACE, _p._eo_raw);

      return _ret_eo;
   }

   /// @internal
   Eo* _concrete_eo_ptr() const { return _eo_ptr(); }
};

static_assert(sizeof(::elm_interface_atspi_selection) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<::elm_interface_atspi_selection>::value, "");


#include "elm_interface_atspi_selection.eo.impl.hh"

#endif // EFL_GENERATED_ELM_INTERFACE_ATSPI_SELECTION_HH

